/* DataBaseType.c generated by valac 0.48.13, the Vala compiler
 * generated from DataBaseType.vala, do not modify */

/*
* Copyright (c) 2011-2018 Alecaddd (http://alecaddd.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alessandro "Alecaddd" Castellani <castellani.ale@gmail.com>
*/

#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define TYPE_DATA_BASE_TYPE (data_base_type_get_type ())
#define DATA_BASE_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_BASE_TYPE, DataBaseType))
#define IS_DATA_BASE_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_BASE_TYPE))
#define DATA_BASE_TYPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATA_BASE_TYPE, DataBaseTypeIface))

typedef struct _DataBaseType DataBaseType;
typedef struct _DataBaseTypeIface DataBaseTypeIface;

struct _DataBaseTypeIface {
	GTypeInterface parent_iface;
	gchar* (*connection_string) (DataBaseType* self, GeeHashMap* data);
	gchar* (*show_schema) (DataBaseType* self);
	gchar* (*show_table_list) (DataBaseType* self, const gchar* name);
	gchar* (*edit_table_name) (DataBaseType* self, const gchar* old_table, const gchar* new_table);
	gchar* (*transfer_table) (DataBaseType* self, const gchar* old_database, const gchar* table, const gchar* new_database);
	gchar* (*show_table_structure) (DataBaseType* self, const gchar* table, const gchar* sortby, const gchar* sort);
	gchar* (*show_table_content) (DataBaseType* self, const gchar* table, gint* count, gint* page, const gchar* sortby, const gchar* sort);
	gchar* (*show_table_relations) (DataBaseType* self, const gchar* table, const gchar* database, const gchar* sortby, const gchar* sort);
	gchar* (*create_database) (DataBaseType* self, const gchar* name);
	gchar* (*delete_database) (DataBaseType* self, const gchar* name);
};

GType data_base_type_get_type (void) G_GNUC_CONST;
gchar* data_base_type_connection_string (DataBaseType* self,
                                         GeeHashMap* data);
gchar* data_base_type_show_schema (DataBaseType* self);
gchar* data_base_type_show_table_list (DataBaseType* self,
                                       const gchar* name);
gchar* data_base_type_edit_table_name (DataBaseType* self,
                                       const gchar* old_table,
                                       const gchar* new_table);
gchar* data_base_type_transfer_table (DataBaseType* self,
                                      const gchar* old_database,
                                      const gchar* table,
                                      const gchar* new_database);
gchar* data_base_type_show_table_structure (DataBaseType* self,
                                            const gchar* table,
                                            const gchar* sortby,
                                            const gchar* sort);
gchar* data_base_type_show_table_content (DataBaseType* self,
                                          const gchar* table,
                                          gint* count,
                                          gint* page,
                                          const gchar* sortby,
                                          const gchar* sort);
gchar* data_base_type_show_table_relations (DataBaseType* self,
                                            const gchar* table,
                                            const gchar* database,
                                            const gchar* sortby,
                                            const gchar* sort);
gchar* data_base_type_create_database (DataBaseType* self,
                                       const gchar* name);
gchar* data_base_type_delete_database (DataBaseType* self,
                                       const gchar* name);
static GType data_base_type_get_type_once (void);

gchar*
data_base_type_connection_string (DataBaseType* self,
                                  GeeHashMap* data)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->connection_string (self, data);
}

gchar*
data_base_type_show_schema (DataBaseType* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->show_schema (self);
}

gchar*
data_base_type_show_table_list (DataBaseType* self,
                                const gchar* name)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->show_table_list (self, name);
}

gchar*
data_base_type_edit_table_name (DataBaseType* self,
                                const gchar* old_table,
                                const gchar* new_table)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->edit_table_name (self, old_table, new_table);
}

gchar*
data_base_type_transfer_table (DataBaseType* self,
                               const gchar* old_database,
                               const gchar* table,
                               const gchar* new_database)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->transfer_table (self, old_database, table, new_database);
}

gchar*
data_base_type_show_table_structure (DataBaseType* self,
                                     const gchar* table,
                                     const gchar* sortby,
                                     const gchar* sort)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->show_table_structure (self, table, sortby, sort);
}

gchar*
data_base_type_show_table_content (DataBaseType* self,
                                   const gchar* table,
                                   gint* count,
                                   gint* page,
                                   const gchar* sortby,
                                   const gchar* sort)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->show_table_content (self, table, count, page, sortby, sort);
}

gchar*
data_base_type_show_table_relations (DataBaseType* self,
                                     const gchar* table,
                                     const gchar* database,
                                     const gchar* sortby,
                                     const gchar* sort)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->show_table_relations (self, table, database, sortby, sort);
}

gchar*
data_base_type_create_database (DataBaseType* self,
                                const gchar* name)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->create_database (self, name);
}

gchar*
data_base_type_delete_database (DataBaseType* self,
                                const gchar* name)
{
	g_return_val_if_fail (self != NULL, NULL);
	return DATA_BASE_TYPE_GET_INTERFACE (self)->delete_database (self, name);
}

static void
data_base_type_default_init (DataBaseTypeIface * iface,
                             gpointer iface_data)
{
}

static GType
data_base_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DataBaseTypeIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) data_base_type_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType data_base_type_type_id;
	data_base_type_type_id = g_type_register_static (G_TYPE_INTERFACE, "DataBaseType", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (data_base_type_type_id, G_TYPE_OBJECT);
	return data_base_type_type_id;
}

GType
data_base_type_get_type (void)
{
	static volatile gsize data_base_type_type_id__volatile = 0;
	if (g_once_init_enter (&data_base_type_type_id__volatile)) {
		GType data_base_type_type_id;
		data_base_type_type_id = data_base_type_get_type_once ();
		g_once_init_leave (&data_base_type_type_id__volatile, data_base_type_type_id);
	}
	return data_base_type_type_id__volatile;
}

